"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.useCurrent = useCurrent;
exports.default = connect;

var _DependencyMap = require("./DependencyMap");

var _BuildComponent = require("./BuildComponent");

var _DependencyMap2 = require("../dependencies/DependencyMap");

var _DispatcherInstance = require("../dispatcher/DispatcherInstance");

var _DispatcherInterface = require("../dispatcher/DispatcherInterface");

var React = _interopRequireWildcard(require("react"));

var _hoistNonReactStatics = _interopRequireDefault(require("hoist-non-react-statics"));

var _useStoreDependency = require("./useStoreDependency");

var _ObjectUtils = require("../utils/ObjectUtils");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return; var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function useCurrent(value) {
  var ref = (0, React.useRef)(value);
  ref.current = value;
  return ref;
}

function connect(dependencies) {
  var dispatcher = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : (0, _DispatcherInstance.get)();
  (0, _DispatcherInterface.enforceDispatcher)(dispatcher);
  return function connector(BaseComponent) {
    var ConnectedComponent = (0, React.forwardRef)(function (props, ref) {
      (0, _DispatcherInterface.enforceDispatcher)(dispatcher);

      var _useState = (0, React.useState)(function () {
        return (0, _DependencyMap.calculateInitial)(dependencies, props, {}) || {};
      }),
          _useState2 = _slicedToArray(_useState, 2),
          dependencyValue = _useState2[0],
          setDependencyValue = _useState2[1];

      var currProps = useCurrent(props);
      (0, _useStoreDependency._useDispatchSubscription)(dependencies, currProps, dispatcher, dependencyValue, setDependencyValue);
      var newValue = (0, _ObjectUtils.oMap)(dependencies, function (dep) {
        return (0, _DependencyMap.calculate)(dep, props, dependencyValue);
      });

      if (!(0, _ObjectUtils.shallowEqual)(newValue, dependencyValue)) {
        setDependencyValue(newValue);
      } // TypeScript really doesn't like how I'm typing the output here
      // @ts-ignore


      return /*#__PURE__*/React.createElement(BaseComponent, _extends({}, props, dependencyValue, {
        ref: ref
      }));
    });
    ConnectedComponent.defaultProps = BaseComponent.defaultProps;
    ConnectedComponent.dependencies = dependencies;
    ConnectedComponent.displayName = (0, _BuildComponent.makeDisplayName)('Connected', BaseComponent);
    ConnectedComponent.propTypes = (0, _DependencyMap2.dependencyPropTypes)(dependencies, BaseComponent.propTypes);
    ConnectedComponent.WrappedComponent = BaseComponent;
    return (0, _hoistNonReactStatics.default)(ConnectedComponent, BaseComponent);
  };
}