"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getActionTypes = getActionTypes;
exports.getDispatcher = getDispatcher;
exports.getDispatchToken = getDispatchToken;
exports.getGetter = getGetter;
exports.getId = getId;
exports.getFactory = getFactory;
exports.getName = getName;
exports.getResponses = getResponses;
exports.getState = getState;
exports.isStore = isStore;

var _Store = _interopRequireDefault(require("./Store"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function getActionTypes(store) {
  return Object.keys(store._responses) || [];
}

function getDispatcher(store) {
  return store._dispatcher;
}

function getDispatchToken(store) {
  return store._dispatchToken;
}

function getGetter(store) {
  return store._getter;
}

function getId(store) {
  return store._uid;
}

function getFactory(store) {
  return store._factory;
}

function getName(store) {
  return store._name;
}

function getResponses(store) {
  return store._responses;
}

function getState(store) {
  return store._state;
}

function isStore(store) {
  return store instanceof _Store.default;
}